### This script calculates the mutational correlation base3d on the SCA analysis

#######################
## PROCEDURE ##
#######################
## Befiore running the script, Run MSA using Jalview or any other program
## Save the alignment file as 'alignment.fasta' and save within the working directory
## Provide the following as input:
## length of the alignment as 'total_length'
## Resuldes to look at with the array as shown below
## total number of residues in consideration

total_length=14


##############   DO NOT CHANGE BELOW THIS LINE #######################################################################################

declare -a amino=('G' 'A' 'L' 'I' 'V' 'F' 'W' 'M' 'P' 'R' 'K' 'D' 'E' 'N' 'Q' 'H' 'S' 'T' 'Y' 'C')
declare -A arr

rm *.temp *.tmp *.pct *.dat

cat << EOF > old.tmp
EOF

# Clean fasta files and make it in sigle lines
awk '{print $1}' alignment.fasta > test.tmp
##remove duplicate sequences
sed -e '/^>/s/$/@/' -e 's/^>/#/' test.tmp | tr -d '\n' | tr "#" "\n" | tr "@" "\t" | sort -u -t $'\t' -f -k 1  | sed -e 's/^/>/' -e 's/\t/\n/' | sed -e 1d > test2.fasta
################################

# convert each character to each column 
for ((i=1; i<=$total_length; i++))
do 
grep -v '>' test2.fasta | awk 'BEGIN{FS="";OFS=" "} {print $x}' x="$i" > 1.tmp
paste old.tmp 1.tmp > new.tmp
cp new.tmp old.tmp
done

mv old.tmp aligned-seq-gap.fasta


# Calculating the counts of residues nx and N for unperturb
N=$(wc -l aligned-seq-gap.fasta | awk '{print $1}')

for ((i=1; i<=$total_length; i++))
do
awk '{print $x}' x="$i" aligned-seq-gap.fasta > $i.tmp
awk '{print}' ${i}.tmp | tr -d -C G | wc -c |  awk '{print "G", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C A | wc -c |  awk '{print "A", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C L | wc -c |  awk '{print "L", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C I | wc -c |  awk '{print "I", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C V | wc -c |  awk '{print "V", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C F | wc -c |  awk '{print "F", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C W | wc -c |  awk '{print "W", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C M | wc -c |  awk '{print "M", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C P | wc -c |  awk '{print "P", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C R | wc -c |  awk '{print "R", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C K | wc -c |  awk '{print "K", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C D | wc -c |  awk '{print "D", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C E | wc -c |  awk '{print "E", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C N | wc -c |  awk '{print "N", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C Q | wc -c |  awk '{print "Q", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C H | wc -c |  awk '{print "H", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C S | wc -c |  awk '{print "S", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C T | wc -c |  awk '{print "T", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C Y | wc -c |  awk '{print "Y", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp
awk '{print}' ${i}.tmp | tr -d -C C | wc -c |  awk '{print "C", $1, x,($1/x)}' x="$N" | awk '{printf  "%4.2f\n", $4}' >> $i-count.tmp

awk '{if ($1 <= 0.3) $1=0.00; printf  "%4.2f\n", $1}' $i-count.tmp > $i-count-1.tmp

xargs < $i-count-1.tmp >> counts
done


