##### This script combines fasta files of proteins
##### convert DNA sequence to protein sequences
##### combine them, and clean them to remove duplicates

##### AB:29/08/2016


cat ../raw_database/uniprot_blastp.fasta ../raw_database/tb_ref_ncbi_prot_blast.fasta ../raw_database/tb_ref_ncbi_prot_blast_patent.fasta ../raw_database/tb_ref_ncbi_prot_blast_metagenome.fasta ../raw_database/tb_ref_ncbi_prot_blast_tsa_nr.fasta > 1.tmp
awk '{print $1}' 1.tmp > 2.tmp


###################################################

csplit ../raw_database/tb_ref_ncbi_prot_tblastn_nr.fasta '%^>%' '/^>/' '{*}'
grep '>gi' ../raw_database/tb_ref_ncbi_prot_tblastn_nr.fasta | wc -l > tot.tmp

tot=$(<tot.tmp)
total=$(($tot - 1))

mv xx00 xx0
mv xx01 xx1
mv xx02 xx2
mv xx03 xx3
mv xx04 xx4
mv xx05 xx5
mv xx06 xx6
mv xx07 xx7
mv xx08 xx8
mv xx09 xx9

i=0
while [ $i -le $total ]
do

awk 'NR==1 {print}' xx$i > first.tmp
sixpack -mstart xx$i -outfile xx${i}.sixpack -outseq xx${i}.fasta
sed '!d;/>/!d;=' xx${i}.fasta > line.tmp
awk 'NR==3 {print}' line.tmp > x.tmp
x=$(<x.tmp)
awk 'NR>1 && NR<xx {print}' xx=$x xx${i}.fasta > seq.tmp
cat first.tmp seq.tmp > prot_${i}.fasta

i=$(($i + 1))
done

cat prot_*.fasta > combined_dna2protein.fa
mv combined_dna2protein.fa tblastn_nr.tmp


################################################

csplit ../raw_database/tb_ref_ncbi_prot_tblastn_pat.fasta '%^>%' '/^>/' '{*}'
grep '>gi' ../raw_database/tb_ref_ncbi_prot_tblastn_pat.fasta | wc -l > tot.tmp

tot=$(<tot.tmp)
total=$(($tot - 1))

mv xx00 xx0
mv xx01 xx1
mv xx02 xx2
mv xx03 xx3
mv xx04 xx4
mv xx05 xx5
mv xx06 xx6
mv xx07 xx7
mv xx08 xx8
mv xx09 xx9

i=0
while [ $i -le $total ]
do

awk 'NR==1 {print}' xx$i > first.tmp
sixpack -mstart xx$i -outfile xx${i}.sixpack -outseq xx${i}.fasta
sed '!d;/>/!d;=' xx${i}.fasta > line.tmp
awk 'NR==3 {print}' line.tmp > x.tmp
x=$(<x.tmp)
awk 'NR>1 && NR<xx {print}' xx=$x xx${i}.fasta > seq.tmp
cat first.tmp seq.tmp > prot_${i}.fasta

i=$(($i + 1))
done

cat prot_*.fasta > combined_dna2protein.fa
mv combined_dna2protein.fa tblastn_pat.tmp

###################################################


cat tblastn_nr.tmp tblastn_pat.tmp | awk '{print $1}' >  3.tmp

cat 2.tmp 3.tmp > 4.fasta

dedupe.sh in=4.fasta out=final_database.fasta



rm xx* *.tmp xx.* prot_*.fasta 4.fasta *.fa


## Clean fasta files
#awk '{print $1}' test.fasta > test1.tmp
##remove duplicate sequences
#sed -e '/^>/s/$/@/' -e 's/^>/#/' test.tmp | tr -d '\n' | tr "#" "\n" | tr "@" "\t" | sort -u -t $'\t' -f -k 2,2  | sed -e 's/^/>/' -e 's/\t/\n/' > test2.fasta


