#!/usr/bin/env bash

TRAJIN=combine.xtc
TRAJOUT=combine_final_now.xtc

# delete the trajectory so gromacs wont display silly backup messages
if [ -e $TRAJOUT ]
then
  rm -f $TRAJOUT
fi

# center molecule (you will be asked!)
gmx_mpi trjconv -pbc mol -center -ur compact -s md_0_1.tpr -f $TRAJIN -o tmp.xtc

# make everything rotate and translate around that molecule (you will be asked!)
gmx_mpi trjconv -fit rot+trans -s md_0_1.tpr -f tmp.xtc -o $TRAJOUT


#choose CA atoms no. 3
gmx_mpi trjconv -s md_0_1.tpr -f $TRAJOUT -o combine_final_CA.xtc

rm -f tmp.xtc

catdcd -otype dcd -o test.dcd -xtc combine_final_CA.xtc



#choose CA atoms no. 3
gmx_mpi trjconv -f combine_final_now.xtc -o ref.pdb -dt 400 -s md_0_1.tpr
#grep '  CA  ' ref.pdb > ref_CA.pdb
