### This script calculates the mutational correlation base3d on the SCA analysis

#######################
## PROCEDURE ##
#######################
## Befiore running the script, Run MSA using Jalview or any other program
## Save the alignment file as 'alignment.fasta' and save within the working directory
## Provide the following as input:
## length of the alignment as 'total_length'
## Resuldes to look at with the array as shown below
## total number of residues in consideration

total_length=275
declare -a array=("40" "41" "44" "45" "48" "52" "57" "59" "62" "69" "72" "73" "75" "98" "103" "124" "143" "193" "220")    
declare -a resno=("28" "29" "32" "33" "36" "40" "45" "47" "50" "56" "59" "60" "62" "85" "90" "111" "128" "175" "200")    
totalres=19



##############   DO NOT CHANGE BELOW THIS LINE #######################################################################################

declare -a amino=('G' 'A' 'L' 'I' 'V' 'F' 'W' 'M' 'P' 'R' 'K' 'D' 'E' 'N' 'Q' 'H' 'S' 'T' 'Y' 'C')
declare -A arr

rm *.temp *.tmp *.pct *.dat

cat << EOF > old.tmp
EOF

# Clean fasta files and make it in sigle lines
awk '{print $1}' alignment.fasta > test.tmp
##remove duplicate sequences
sed -e '/^>/s/$/@/' -e 's/^>/#/' test.tmp | tr -d '\n' | tr "#" "\n" | tr "@" "\t" | sort -u -t $'\t' -f -k 2,2  | sed -e 's/^/>/' -e 's/\t/\n/' > test2.fasta
################################

# convert each character to each column 
for ((i=1; i<$total_length; i++))
do 
grep -v '>' test2.fasta | awk 'BEGIN{FS="";OFS=" "} {print $x}' x="$i" > 1.tmp
paste old.tmp 1.tmp > new.tmp
cp new.tmp old.tmp
done

mv old.tmp aligned-seq-gap.fasta


# Calculating the counts of residues nx and N for unperturb
N=$(wc -l aligned-seq-gap.fasta | awk '{print $1}')

for ((i=0; i<$totalres; i++))
do
awk '{print $x}' x="${array[$i]}" aligned-seq-gap.fasta > ${array[$i]}.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C G | wc -c |  awk '{print "G", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C A | wc -c |  awk '{print "A", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C L | wc -c |  awk '{print "L", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C I | wc -c |  awk '{print "I", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C V | wc -c |  awk '{print "V", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C F | wc -c |  awk '{print "F", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C W | wc -c |  awk '{print "W", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C M | wc -c |  awk '{print "M", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C P | wc -c |  awk '{print "P", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C R | wc -c |  awk '{print "R", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C K | wc -c |  awk '{print "K", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C D | wc -c |  awk '{print "D", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C E | wc -c |  awk '{print "E", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C N | wc -c |  awk '{print "N", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C Q | wc -c |  awk '{print "Q", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C H | wc -c |  awk '{print "H", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C S | wc -c |  awk '{print "S", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C T | wc -c |  awk '{print "T", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C Y | wc -c |  awk '{print "Y", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
awk '{print}' ${array[$i]}.tmp | tr -d -C C | wc -c |  awk '{print "C", $1, x,($1/x)*100}' x="$N" >> ${array[$i]}-count.tmp
done


for ((i=0; i<$totalres; i++))
do
###### Percent population more than 5% ###########

awk '$4 > 5 {print $1, $2}' ${array[$i]}-count.tmp > ${array[$i]}-count-present.tmp
lines=$(wc -l ${array[$i]}-count-present.tmp | awk '{print $1}')

for ((j=1; j <= $lines; j++))
do
res=$(awk 'NR==xx {print $1}' xx="$j" ${array[$i]}-count-present.tmp)
awk '$xx==yy {print}' xx="${array[$i]}" yy="$res"  aligned-seq-gap.fasta > ${array[$i]}_${res}_align-seq-gap.tmp
N=$(wc -l ${array[$i]}_${res}_align-seq-gap.tmp | awk '{print $1}')

for ((k=$((i + 1)); k<$totalres; k++))
do

awk '{print $x}' x="${array[$k]}"  ${array[$i]}_${res}_align-seq-gap.tmp > ${array[$k]}.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C G | wc -c |  awk '{print xx, "G", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C A | wc -c |  awk '{print xx, "A", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C L | wc -c |  awk '{print xx, "L", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C I | wc -c |  awk '{print xx, "I", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C V | wc -c |  awk '{print xx, "V", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C F | wc -c |  awk '{print xx, "F", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C W | wc -c |  awk '{print xx, "W", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C M | wc -c |  awk '{print xx, "M", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C P | wc -c |  awk '{print xx, "P", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C R | wc -c |  awk '{print xx, "R", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C K | wc -c |  awk '{print xx, "K", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C D | wc -c |  awk '{print xx, "D", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C E | wc -c |  awk '{print xx, "E", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C N | wc -c |  awk '{print xx, "N", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C Q | wc -c |  awk '{print xx, "Q", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C H | wc -c |  awk '{print xx, "H", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C S | wc -c |  awk '{print xx, "S", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C T | wc -c |  awk '{print xx, "T", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C Y | wc -c |  awk '{print xx, "Y", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp
awk '{print}' ${array[$k]}.tmp | tr -d -C C | wc -c |  awk '{print xx, "C", $1, x,($1/x)*100}' x="$N" xx="$res" >> ${array[$i]}-${res}-${array[$k]}-count.tmp

paste ${array[$i]}-count.tmp ${array[$i]}-${res}-${array[$k]}-count.tmp | awk '{print $5,$1, $9 - $4}' | awk '$3 > 0 {print $1, $2, $3, $3*x}' x="$N" >> ${array[$i]}-${array[$k]}-dG.tmp
#paste ${array[$k]}-count.tmp ${array[$i]}-${res}-${array[$k]}-count.tmp | awk '{print $5,$1, $9 - $4}' | awk '$3 > 0 {print $1, $2, $3, $3*x}' x="$N" >> ${array[$i]}-${array[$k]}-dG.tmp
#paste ${array[$k]}-count.tmp ${array[$i]}-${res}-${array[$k]}-count.tmp | awk '{print $5,$1, $9 - $4}' | sed -e 's/-//g' | awk '{print $1, $2, $3, $3*x}' x="$N" >> ${array[$i]}-${array[$k]}-dG.tmp

tot=$(awk '{sum+=$4}END{print sum'} ${array[$i]}-${array[$k]}-dG.tmp)
#awk '{print $1, $2, ($4/xx)*100}' xx="$tot" ${array[$i]}-${array[$k]}-dG.tmp > ${array[$i]}-${array[$k]}-dG-pct.pct
awk '{print $1, $2, ($4/xx)*100, $4}'  xx="$tot" ${array[$i]}-${array[$k]}-dG.tmp > ${array[$i]}-${array[$k]}-dG-pct.pct

#echo ${array[$i]} ${array[$k]} $tot >> residue-pair-coupling.tmp
done
done
done

##### Calculating results for residue coupling #########

for ((x=0; x<$totalres; x++))
do
y=$(($x + 1))
for (( m=$y; m<$totalres; m++ ))
do
file=${array[$x]}-${array[$m]}-dG-pct.pct


for ((i=0; i<20; i++))
do
for ((j=0; j<20; j++))
do
arr[$i,$j]=0.0
done
done

lines=$(wc -l $file | awk '{print $1}')

for ((i=1; i<=$lines; i++))
do
first=$(awk 'NR==x {print $1}' x="$i" $file)
second=$(awk 'NR==x {print $2}' x="$i" $file)
third=$(awk 'NR==x {printf "%3.1f",$3}' x="$i" $file)

for ((j=0; j<20; j++))
do
if [ $first == ${amino[$j]} ]
then
one=$j
fi
if [ $second == ${amino[$j]} ]
then
two=$j
fi
done
arr[$one,$two]=$third
done


for ((i=0; i<20; i++))
do
echo ${amino[$i]} >> amino.temp
for ((j=0; j<20; j++))
do
echo ${arr[$i,$j]} >> temp
done
awk '{print $1}' temp | xargs >> result.temp
rm temp
done

#paste amino.temp result.temp > ${array[$x]}-${array[$m]}-coupling.dat  
paste amino.temp result.temp > ${resno[$x]}-${resno[$m]}-coupling.dat  

#Considering MAX values
maxi=$(awk -v max=0 '{if($3>max){want=$3; max=$3}}END{print want}' ${array[$x]}-${array[$m]}-dG-pct.pct)
echo ${array[$x]} ${array[$m]} $maxi >> residue-pair-coupling.tmp

#Considering Summation
#summation=$(awk '{sum+=$4}END{print sum}' ${array[$x]}-${array[$m]}-dG-pct.pct)
#echo ${array[$x]} ${array[$m]} $summation >> residue-pair-coupling.tmp
rm *.temp
done
done

maxi=$(awk -v max=0 '{if($3>max){want=$3; max=$3}}END{print want}' residue-pair-coupling.tmp)
mini=$(awk -v max=99999999 '{if($3<max){want=$3; max=$3}}END{print want}' residue-pair-coupling.tmp)
awk '{print $1, $2, ($3-mn)/(mx-mn)}' mn="$mini" mx="$maxi" residue-pair-coupling.tmp > residue-pair-coupling-normalized-1.tmp
awk '{if ($3 <= 0.01) $3=0.01; print $1, $2, $3}' residue-pair-coupling-normalized-1.tmp > residue-pair-coupling-normalized.tmp

############### Inter-site coupling ###################

file='residue-pair-coupling-normalized.tmp'


for ((i=0; i<$totalres; i++))
do
for ((j=$i; j<$totalres; j++))
do
arr[$i,$j]=0.00
done
done

lines=$(wc -l $file | awk '{print $1}')

for ((i=1; i<=$lines; i++))
do
first=$(awk 'NR==x {print $1}' x="$i" $file)
second=$(awk 'NR==x {print $2}' x="$i" $file)
third=$(awk 'NR==x {printf "%4.2f",$3}' x="$i" $file)

for ((j=0; j<$totalres; j++))
do
if [ $first == ${array[$j]} ]
then
one=$j
fi
if [ $second == ${array[$j]} ]
then
two=$j
fi
done
arr[$one,$two]=$third
arr[$two,$one]=$third
#echo $first $second $arr[$one,$two]
done


for ((i=0; i<$totalres; i++))
do
echo ${resno[$i]} >> resi.temp
for ((j=0; j<$totalres; j++))
do
echo ${arr[$i,$j]} >> array1.temp
done
awk '{print $1}' array1.temp | xargs >> array2.temp
rm array1.temp
done
paste resi.temp array2.temp > Inter-residue-correl.dat 

#rm *.tmp *.temp *.pct *pct.dat
