rm *.tmp file surf x.fasta *.mcr *.fasta

run=1

while [ $run -le 10 ]
do



## consider 4 random surface residues ##
shuf -i 1-24 -n 4 > surf

x=1

while [ $x -le 4 ]
do
line=$(awk 'NR==xx {print $1}' xx="$x" surf)
awk 'NR==jj {print $1, $2}' jj="$line" mutation.database >> wt_res.tmp
x=$(($x + 1))
done


shuf -i 1-18 -n 4 > surf
i=1
while [ $i -le 4 ]
do
line=$(awk 'NR==xx {print $1}' xx="$i" surf)
awk 'NR==jj {print $1, $2}' jj="$line" aa.database >> res2mut.tmp

echo ",Isomer=L" >> isomer.tmp
echo "SwapRes" >> initial.tmp

i=$(($i + 1))
done


echo "LoadSce is15_tsant.sce" > residues_2_mutate.mcr
paste initial.tmp wt_res.tmp res2mut.tmp isomer.tmp | awk '{print $1,$2,$3,",",$4,$5}' >> residues_2_mutate.mcr
echo "SaveSce mut.sce" >> residues_2_mutate.mcr
echo "quit" >> residues_2_mutate.mcr
yasara -txt residues_2_mutate.mcr "MacroTArget='is15_tsant'"


cat << EOF > wt.mcr
Clear
LoadSce is15_tsant.sce
Clean
ForceField NOVA,SetPar=No
Experiment Minimization
Experiment On
Wait ExpEnd
quit
EOF


cat << EOF > mut.mcr
Clear
LoadSce mut.sce
Clean
ForceField NOVA,SetPar=No
Experiment Minimization
Experiment On
Wait ExpEnd
quit
EOF

yasara -txt wt.mcr "MacroTarget='is15_tsant'" > outputwt.tmp
yasara -txt mut.mcr "MacroTarget='mut'" > outputmut.tmp


wt_em=$(grep 'Final energy' outputwt.tmp | awk '{print $11}')
mu_em=$(grep 'Final energy' outputmut.tmp | awk '{print $11}')


##### Genarating One Letter Code for WT and Mutant ######

paste wt_res.tmp res2mut.tmp | awk '{print $1,"  ",$3}' > file.tmp

x=$(wc -l file.tmp | awk '{print $1}')

a0=(Ala Gly Val Leu Ile Met Cys Pro Arg Lys His Asp Glu Asn Gln Phe Tyr Trp Ser Thr)
a1=(ALA GLY VAL LEU ILE MET CYS PRO ARG LYS HIS ASP GLU ASN GLN PHE TYR TRP SER THR)
a2=(A G V L I M C P R K H D E N Q F Y W S T)

for ((i=1;i<=$x;i++))
do
aa_1=$(awk 'NR==xx {print $1}' xx="$i" file.tmp)
aa_2=$(awk 'NR==yy {print $2}' yy="$i" file.tmp)

for ((j=0;j<20;j++))
do
if [ $aa_1 == ${a1[$j]} ]
then
aa_1=${a2[$j]}
echo $aa_1 >> a1.tmp
fi
if [ $aa_2 == ${a0[$j]} ]
then
aa_2=${a2[$j]}
echo $aa_2 >> a2.tmp
fi

done
done


paste a1.tmp a2.tmp > file


#### DO NOT CHANGE #######

cat << EOF > nova.tmp
Gly  G   -21.64
Ala  A   -20.64
Val  V   -25.27
Leu  L   -30.31
Ile  I   -23.13
Pro  P   -14.57
Met  M   -19.90
Cys  C   -15.85
Lys  K   -2.23
Arg  R   -76.43
Asp  D   -26.75
Glu  E   -27.07
Asn  N   -40.49
Gln  Q   -34.96
Tyr  Y   -18.96
Phe  F   -17.94
Trp  W   -14.41
His  H   -17.49
Ser  S   -20.77
Thr  T   -23.19
EOF

i=1
l=$(wc -l file | awk '{print $1}')

for (( i=1; i <= $l; i++ ))
do
wt=$(awk 'NR==xx {print  $1}' "xx=${i}" file)
mut=$(awk 'NR==xx {print  $2}' "xx=${i}" file)


        for (( x=1; x <= 20; x++ ))
        do
        aa=$(awk 'NR==yy {print  $2}' "yy=${x}" nova.tmp)
        val=$(awk 'NR==yy {print  $3}' "yy=${x}" nova.tmp)

        if [ $aa == ${wt} ]
        then
        echo $val >> wt.tmp
        fi

        if [ $aa == ${mut} ]
        then
        echo $val >> mut.tmp
        fi

        done
done


mm=$(awk '{sum+=$1}END{print sum}' wt.tmp)
nn=$(awk '{sum+=$1}END{print sum}' mut.tmp)

ddG=$(echo "($mu_em - $nn) - ($wt_em - $mm)" | bc)
#echo "($mu_em - $nn) - ($wt_em - $mm)" | bc

echo $ddG


cat << EOF > save_fasta.mcr
LoadSce mut.sce
SaveSeqMol Atom 1,Filename=x.fasta,Join=No
quit
EOF

limit=0.0
if (( $(echo "$ddG < $limit" |bc -l) ))
then
echo "favorable"
yasara -txt save_fasta.mcr "MacroTarget='mut'"
awk '{print $1}' x.fasta > x.fasta.tmp
sed -e s/Object/IS15_MUT_FM_$run/g x.fasta.tmp > is15_mut_fm_${run}.fasta
echo $ddG >> ddG.dat
cp mut.sce mut_${run}.sce
else
echo "unfavorable"
fi


rm *.tmp file surf x.fasta 
run=$(($run + 1))
done
