rm *.tmp *.mcr *.data ddG*

DATABASE="database1.dat"
#file="1l63"

len=$(wc -l ${DATABASE} | awk '{print $1}')

x=1

while [ $x -le $len ]
do

file=$(awk 'NR==jj {print $1}' jj="$x" ${DATABASE})
cp ../${file}.pdb .


awk 'NR==jj {print $2, $3}' jj="$x" ${DATABASE} > wt_res.tmp
awk 'NR==jj {print $4}' jj="$x" ${DATABASE} > res2mut.tmp

res=$(awk 'NR==jj {print $3}' jj="$x" ${DATABASE})

#PHUNIT=$(awk 'NR==jj {print $5}' jj="$x" ${DATABASE})
expt=$(awk 'NR==jj {print $5}' jj="$x" ${DATABASE})

echo ",Isomer=L" > isomer.tmp
echo "SwapRes" > initial.tmp


resnum=$(grep 'ATOM' ${file}.pdb | awk 'NR==1 {print $6}')
i=$(($resnum - 1))
m=$(($res - $i))
mm=$(($m * 2))

echo $resnum $res $m $mm


cat << EOF > wt.mcr
Clear
LoadPDB  ${file}.pdb
Clean
ForceField NOVA,SetPar=No
Experiment Minimization
Experiment On
Wait ExpEnd
SaveSce wt.sce
Boundary Periodic
SolvPar eSolute=2,eSolvent=78,Resolution=0.25,IonCon=0
Coulomb,vdw = SolvEnergy
SolvEnergy
energylist() = SolvEnergyRes Obj $file
Print '(energylist($m))'
Print '(energylist($mm))'
quit
EOF


echo "LoadSce wt.sce" > mut.mcr
paste initial.tmp wt_res.tmp res2mut.tmp isomer.tmp | awk '{print $1,$2,$3,",",$4,$5}' >> mut.mcr
echo "Clean" >> mut.mcr
echo "ForceField NOVA,SetPar=No" >> mut.mcr
echo "Experiment Minimization" >> mut.mcr
echo "Experiment On" >> mut.mcr
echo "Wait ExpEnd" >> mut.mcr
echo "Boundary Periodic" >> mut.mcr
echo "SolvPar eSolute=2,eSolvent=78,Resolution=0.25,IonCon=0" >> mut.mcr
echo "Coulomb,vdw = SolvEnergy" >> mut.mcr
echo "SolvEnergy" >> mut.mcr
echo "energylist() = SolvEnergyRes Obj ${file}" >> mut.mcr
echo "Print '(energylist($m))'" >> mut.mcr
echo "Print '(energylist($mm))'" >> mut.mcr
echo "quit" >> mut.mcr


wtres=$(awk 'NR==jj {print $2}' jj="$x" ${DATABASE})
mutres=$(awk 'NR==jj {print $4}' jj="$x" ${DATABASE})


cat << EOF > wt_res_min.mcr
Clear
BuildRes $wtres
AddCap ACE+NME
Clean
ForceField NOVA,SetPar=No
Experiment Minimization
Experiment On
Wait ExpEnd
Boundary Periodic
SolvPar eSolute=2,eSolvent=78,Resolution=0.25,IonCon=0
Coulomb,vdw = SolvEnergy
SolvEnergy
SaveSce wt_res.sce
quit
EOF

echo "LoadSce wt_res.sce" > mut_res_min.mcr
paste initial.tmp wt_res.tmp res2mut.tmp isomer.tmp | awk '{print $1,$2,$3,",",$4,$5}' >> mut_res_min.mcr
echo "Clean" >> mut_res_min.mcr
echo "ForceField NOVA,SetPar=No" >> mut_res_min.mcr
echo "Experiment Minimization" >> mut_res_min.mcr
echo "Experiment On" >> mut_res_min.mcr
echo "Wait ExpEnd" >> mut_res_min.mcr
echo "Boundary Periodic" >> mut_res_min.mcr
echo "SolvPar eSolute=2,eSolvent=78,Resolution=0.25,IonCon=0" >> mut_res_min.mcr
echo "Coulomb,vdw = SolvEnergy" >> mut_res_min.mcr
echo "SolvEnergy" >> mut_res_min.mcr
echo "quit" >> mut_res_min.mcr


yasara -txt wt.mcr "MacroTarget='${file}'" > outputwt.tmp
yasara -txt mut.mcr "MacroTarget='mut'" > outputmut.tmp
yasara -txt wt_res_min.mcr "MacroTarget='wt_res'" > outputwt_res.tmp
yasara -txt mut_res_min.mcr "MacroTarget='mut_res'" > outputmut_res.tmp


#wt_em=$(grep 'Final energy' outputwt.tmp | awk '{print $11}')
#mu_em=$(grep 'Final energy' outputmut.tmp | awk '{print $11}')

wt_em=$(tail -4 outputwt.tmp | grep -v 'Macro' | awk '{sum+=$1}END{print sum}')
mu_em=$(tail -4 outputmut.tmp | grep -v 'Macro' | awk '{sum+=$1}END{print sum}')


wt_res_em=$(grep 'Coulomb' outputwt_res.tmp | awk '{print $10, $13}' | sed 's/,/ /g'| awk '{print $1 + $2}') 
mut_res_em=$(grep 'Coulomb' outputmut_res.tmp | awk '{print $10, $13}' | sed 's/,/ /g'| awk '{print $1 + $2}')



ddG=$(echo "($mu_em - $mut_res_em) - ($wt_em - $wt_res_em)" | bc)

echo $expt "   " $ddG >> ddG.dat


#rm *.tmp *.mcr 
x=$(($x + 1))
done
